<?php
/*
 * Created For BZ9.com
 * Author: Dave
 * Copyright: BZ9.com
 * Licence: Commercial, See included licence file.
 */
if(!defined("APPLICATION_PATH")){ die("No DIRECT Access"); }

class template
{
    Private $Reg;
    private $theme = "default";
    private $section = "admin";
    private $view;
    private $data;
    private $ajax=false;


    public function __construct($Registry){
        $this->Reg = $Registry;
        $this->Reg->log->log("class_load","Template Class");
    }

    public function set_theme($theme)
    {
        if(is_dir(APPLICATION_PATH."/themes/".$theme)){
            $this->theme = $theme;
        }
    }

    public function set_section($section)
    {
        if(is_dir(APPLICATION_PATH."/themes/".$this->theme."/".$section)){
            $this->section = $section;
        }
    }

    private function build_page()
    {
        $this->data = $this->Reg->error->get_all($this->data);

        if($this->data){
        extract($this->data);
        }
        $site_url = $this->Reg->settings->Config("site_url");
        $theme_url = $this->Reg->settings->Config("site_url")."/themes/".$this->theme."/".$this->section;
        $database_type = $this->Reg->settings->Config("database_type");
        $reseller = "n";
        if(isset($_SESSION['memid']))
        {
            $reseller = $this->Reg->licence['file']['reseller'];
        }

        ob_start(array($this, 'build_page_vars'));
        if(!$this->ajax){
            if(file_exists(APPLICATION_PATH."/themes/".$this->theme."/".$this->section."/header.php"))
            {
                include_once(APPLICATION_PATH."/themes/".$this->theme."/".$this->section."/header.php");
            }
        }

        include_once(APPLICATION_PATH."/views/".$this->view.".php");

        if(!$this->ajax){
            if(file_exists(APPLICATION_PATH."/themes/".$this->theme."/".$this->section."/header.php"))
            {
                include_once(APPLICATION_PATH."/themes/".$this->theme."/".$this->section."/footer.php");
            }
        }
        ob_end_flush();
        exit;
    }

    public function showview($view, $data=null, $ajax=null)
    {
        if($data){ $this->data = $data; }
        if($ajax){ $this->ajax = true; }
        if(file_exists(APPLICATION_PATH."/views/".$view.".php"))
        {
            $this->view = $view;
            $this->build_page();
        } else {
            $this->Reg->error->raise_error("fatal","The requested view file does not exist.","admin");
        }
    }

    public function show404()
    {
        if(file_exists(APPLICATION_PATH."/themes/".$this->theme."/".$this->section."/404.php"))
        {
            include_once(APPLICATION_PATH."/themes/".$this->theme."/".$this->section."/404.php");
        }
        exit;
    }
    private function build_page_vars($buffer)
    {
        //return (str_replace("Type", "oranges", $buffer));
        return $buffer;
    }

}
